(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["pmxOverlay"] = factory();
	else
		root["pmxOverlay"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = overlay;
	
	var _pmxUtilDom = __webpack_require__(!(function webpackMissingModule() { var e = new Error("Cannot find module \"pmx-util-dom\""); e.code = 'MODULE_NOT_FOUND'; throw e; }()));
	
	function __onActivate(_ref, paramTargetEl) {
	  var el = _ref.el;
	  var targetEl = _ref.targetEl;
	  var focus = _ref.focus;
	  var css = _ref.css;
	  var onActivateHandler = _ref.onActivateHandler;
	  var config = _ref.config;
	  var removeScrollingOnActivate = config.removeScrollingOnActivate;
	  var classes = css.classes;
	
	
	  if (targetEl === paramTargetEl) {
	    (0, _pmxUtilDom.__removeClass)({ el: el, className: classes.get('deactivated') });
	    __addCSSClass({
	      el: el,
	      className: classes.get('activated'),
	      config: config
	    });
	
	    if (removeScrollingOnActivate) {
	      __addCSSClass({
	        el: document.body,
	        className: classes.get('noscrolling'),
	        config: config
	      });
	    }
	
	    if (typeof onActivateHandler === 'function') {
	      onActivateHandler({ el: el, targetEl: targetEl, focus: focus, css: css });
	    }
	    focus.activate();
	  }
	}
	
	function __onDeactivate(_ref2, paramTargetEl) {
	  var el = _ref2.el;
	  var targetEl = _ref2.targetEl;
	  var focus = _ref2.focus;
	  var css = _ref2.css;
	  var onDeactivateHandler = _ref2.onDeactivateHandler;
	  var config = _ref2.config;
	  var removeScrollingOnActivate = config.removeScrollingOnActivate;
	  var classes = css.classes;
	
	  if (targetEl === paramTargetEl) {
	    (0, _pmxUtilDom.__removeClass)({ el: el, className: classes.get('activated') });
	    if (removeScrollingOnActivate) {
	      (0, _pmxUtilDom.__removeClass)({ el: document.body, className: classes.get('noscrolling') });
	    }
	    __addCSSClass({
	      el: el,
	      className: classes.get('deactivated'),
	      config: config
	    });
	    if (typeof onDeactivateHandler === 'function') {
	      onDeactivateHandler({ el: el, targetEl: targetEl, focus: focus, css: css });
	    }
	    focus.deactivate();
	  }
	}
	
	function __onClickOutside(_ref3) {
	  var config = _ref3.config;
	  var shared = _ref3.shared;
	  var events = config.events;
	  var targetEl = config.targetEl;
	  var emitter = shared.emitter;
	
	
	  emitter.emit(events.get('deactivate'), targetEl);
	}
	
	function __attachListeners(_ref4) {
	  var config = _ref4.config;
	  var shared = _ref4.shared;
	  var el = config.el;
	  var targetEl = config.targetEl;
	  var events = config.events;
	  var css = config.css;
	  var onActivateHandler = config.onActivateHandler;
	  var onDeactivateHandler = config.onDeactivateHandler;
	  var addedEventListeners = config.addedEventListeners;
	  var initialFocusSelector = config.initialFocusSelector;
	  var emitter = shared.emitter;
	  var focusTrap = shared.focusTrap;
	
	  var registeredListeners = [];
	  var focusConfig = {
	    onDeactivate: function onDeactivate() {
	      if (typeof onDeactivateHandler === 'function') {
	        onDeactivateHandler({ el: el, targetEl: targetEl });
	      }
	    },
	
	    escapeDeactivates: false
	  };
	
	  if (initialFocusSelector) {
	    focusConfig.initialFocus = initialFocusSelector;
	  }
	
	  var focus = focusTrap(targetEl, focusConfig);
	  var handlers = new Map([['activate', __onActivate.bind(null, { el: el, targetEl: targetEl, focus: focus, css: css, onActivateHandler: onActivateHandler, config: config })], ['deactivate', __onDeactivate.bind(null, { el: el, targetEl: targetEl, focus: focus, css: css, onDeactivateHandler: onDeactivateHandler, config: config })], ['clickoutside', __onClickOutside.bind(null, { config: config, shared: shared, focus: focus })]]);
	
	  el.addEventListener('click', handlers.get('clickoutside'), false);
	  registeredListeners.push({
	    eventType: 'click',
	    handler: handlers.get('clickoutside')
	  });
	  addedEventListeners.set(el, registeredListeners);
	
	  events.forEach(function (evt, type) {
	    emitter.on(evt, handlers.get(type));
	  });
	}
	
	function __checkAndGetElement(_ref5) {
	  var el = _ref5.el;
	  var type = _ref5.type;
	
	  var errorMsg = '[pmx-overlay] ' + type + ' needs to be DOM element or a valid selector for .querySelector()';
	  var validEl = void 0;
	  if (el === undefined || el.nodeName === undefined && typeof el !== 'string') {
	    throw new Error(errorMsg);
	  } else if (typeof el === 'string') {
	    try {
	      validEl = document.querySelector(el);
	    } catch (e) {
	      throw new Error(errorMsg);
	    }
	  } else if (el.nodeName) {
	    validEl = el;
	  }
	
	  return validEl;
	}
	
	function __removeListeners(_ref6) {
	  var config = _ref6.config;
	  var shared = _ref6.shared;
	  var addedEventListeners = config.addedEventListeners;
	  var events = config.events;
	  var emitter = shared.emitter;
	
	
	  events.forEach(function (evt, type) {
	    emitter.removeAllListeners(type);
	  });
	
	  addedEventListeners.forEach(function (options, elem) {
	    if (Array.isArray(options)) {
	      options.forEach(function (option) {
	        elem.removeEventListener(option.eventType, option.handler);
	      });
	    } else {
	      elem.removeEventListener(options.eventType, options.handler);
	    }
	  });
	}
	
	function __addCSSClass(_ref7) {
	  var el = _ref7.el;
	  var className = _ref7.className;
	  var config = _ref7.config;
	
	  var cssClasses = [];
	  var mutatedElementsByCSS = config.mutatedElementsByCSS;
	
	
	  if (typeof className === 'string') {
	    cssClasses.push(className);
	  } else if (Array.isArray(className)) {
	    /**
	     * for now we won't support 'level' classes when passing an array
	     * as a parameter to avoid adding too many css classes to each elem
	     */
	    cssClasses = className;
	  } else {
	    throw new Error('there is a error with the type of the passed CSS classes');
	  }
	
	  // css classes filtering the ones that are empty
	  var classesToBeApplied = cssClasses.filter(function (item) {
	    return item;
	  });
	  // add the classes to the DOM elem
	  (0, _pmxUtilDom.__addClass)({ el: el, className: classesToBeApplied });
	
	  if (mutatedElementsByCSS.has(el)) {
	    mutatedElementsByCSS.get(el).push(classesToBeApplied);
	  } else {
	    mutatedElementsByCSS.set(el, classesToBeApplied);
	  }
	
	  return classesToBeApplied;
	}
	
	function __removeOverlay(_ref8) {
	  var config = _ref8.config;
	  var shared = _ref8.shared;
	  var mutatedElementsByCSS = config.mutatedElementsByCSS;
	
	
	  mutatedElementsByCSS.forEach(function (classes, elem) {
	    (0, _pmxUtilDom.__removeClass)({ el: elem, className: classes });
	  });
	
	  __removeListeners({ config: config, shared: shared });
	}
	
	function overlay() {
	  return {
	    init: function init(cfg, shared) {
	      var config = Object.assign({
	        mutatedElementsByCSS: new Map(), // Map to keep track of mutated DOM elements. Handy to remove all the CSS classes when stoping the component
	        events: new Map([['activate', 'pmx:activate'], // the overlay will get activated when this event (along the
	        // targetEl) gets triggered
	        ['deactivate', 'pmx:deactivate']]),
	        css: {
	          classes: new Map([['overlayElement', 'Overlay'], ['activated', 'is-active'], ['deactivated', 'is-deactivated'], ['noscrolling', 'is--noscrolling']])
	        },
	        removeScrollingOnActivate: true }, cfg);
	
	      config.el = __checkAndGetElement({ el: config.el, type: 'el' });
	      config.targetEl = __checkAndGetElement({ el: config.targetEl, type: 'targetEl' });
	      config.addedEventListeners = new Map(); // Map to keep track of added Event Listeners. Handy to remove all the listeners when stoppping the component
	      this.config = config;
	      __attachListeners({ config: config, shared: shared });
	    },
	    stop: function stop(config, shared) {
	      if (config) {
	        Object.assign(this.config, config);
	      }
	      __removeOverlay({ config: this.config, shared: shared });
	    }
	  };
	}

/***/ }
/******/ ])
});
;
//# sourceMappingURL=pmx-overlay.js.map